unit schEmpresasServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schEmpresasClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_EmpresasDelta = '{43119B6A-7006-4045-B378-1516B8CA32E1}';
  RID_EmpresasDatosBancoDelta = '{A79108BB-E362-4338-9188-6D5683DCE289}';

type
  { IEmpresasDelta }
  IEmpresasDelta = interface(IEmpresas)
  ['{43119B6A-7006-4045-B378-1516B8CA32E1}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldNIF_CIFValue : String;
    function GetOldNOMBREValue : String;
    function GetOldRAZON_SOCIALValue : String;
    function GetOldCALLEValue : String;
    function GetOldPOBLACIONValue : String;
    function GetOldPROVINCIAValue : String;
    function GetOldCODIGO_POSTALValue : String;
    function GetOldTELEFONO_1Value : String;
    function GetOldTELEFONO_2Value : String;
    function GetOldMOVIL_1Value : String;
    function GetOldMOVIL_2Value : String;
    function GetOldFAXValue : String;
    function GetOldEMAIL_1Value : String;
    function GetOldEMAIL_2Value : String;
    function GetOldPAGINA_WEBValue : String;
    function GetOldNOTASValue : IROStrings;
    function GetOldFECHA_ALTAValue : DateTime;
    function GetOldFECHA_MODIFICACIONValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldLOGOTIPOValue : IROStream;
    function GetOldREGISTRO_MERCANTILValue : String;
    function GetOldPARAM_TIEMPOValue : Float;
    function GetOldPARAM_MARGENValue : Float;
    function GetOldID_TIPO_IVAValue : SmallInt;
    function GetOldID_FORMA_PAGOValue : SmallInt;
    function GetOldID_ALMACENValue : SmallInt;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldNIF_CIF : String read GetOldNIF_CIFValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldRAZON_SOCIAL : String read GetOldRAZON_SOCIALValue;
    property OldCALLE : String read GetOldCALLEValue;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property OldCODIGO_POSTAL : String read GetOldCODIGO_POSTALValue;
    property OldTELEFONO_1 : String read GetOldTELEFONO_1Value;
    property OldTELEFONO_2 : String read GetOldTELEFONO_2Value;
    property OldMOVIL_1 : String read GetOldMOVIL_1Value;
    property OldMOVIL_2 : String read GetOldMOVIL_2Value;
    property OldFAX : String read GetOldFAXValue;
    property OldEMAIL_1 : String read GetOldEMAIL_1Value;
    property OldEMAIL_2 : String read GetOldEMAIL_2Value;
    property OldPAGINA_WEB : String read GetOldPAGINA_WEBValue;
    property OldNOTAS : IROStrings read GetOldNOTASValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldLOGOTIPO : IROStream read GetOldLOGOTIPOValue;
    property OldREGISTRO_MERCANTIL : String read GetOldREGISTRO_MERCANTILValue;
    property OldPARAM_TIEMPO : Float read GetOldPARAM_TIEMPOValue;
    property OldPARAM_MARGEN : Float read GetOldPARAM_MARGENValue;
    property OldID_TIPO_IVA : SmallInt read GetOldID_TIPO_IVAValue;
    property OldID_FORMA_PAGO : SmallInt read GetOldID_FORMA_PAGOValue;
    property OldID_ALMACEN : SmallInt read GetOldID_ALMACENValue;
  end;

  { TEmpresasBusinessProcessorRules }
  TEmpresasBusinessProcessorRules = class(TDABusinessProcessorRules, IEmpresas, IEmpresasDelta)
  private
    f_NOTAS: IROStrings;
    f_LOGOTIPO: IROStream;
    procedure NOTAS_OnChange(Sender: TObject);
    procedure LOGOTIPO_OnChange(Sender: Tobject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetNIF_CIFValue: String; virtual;
    function GetNIF_CIFIsNull: Boolean; virtual;
    function GetOldNIF_CIFValue: String; virtual;
    function GetOldNIF_CIFIsNull: Boolean; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    procedure SetNIF_CIFIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    function GetOldNOMBREValue: String; virtual;
    function GetOldNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetRAZON_SOCIALValue: String; virtual;
    function GetRAZON_SOCIALIsNull: Boolean; virtual;
    function GetOldRAZON_SOCIALValue: String; virtual;
    function GetOldRAZON_SOCIALIsNull: Boolean; virtual;
    procedure SetRAZON_SOCIALValue(const aValue: String); virtual;
    procedure SetRAZON_SOCIALIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    function GetCALLEIsNull: Boolean; virtual;
    function GetOldCALLEValue: String; virtual;
    function GetOldCALLEIsNull: Boolean; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    function GetOldPOBLACIONValue: String; virtual;
    function GetOldPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    function GetOldPROVINCIAValue: String; virtual;
    function GetOldPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    function GetOldCODIGO_POSTALValue: String; virtual;
    function GetOldCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetTELEFONO_1Value: String; virtual;
    function GetTELEFONO_1IsNull: Boolean; virtual;
    function GetOldTELEFONO_1Value: String; virtual;
    function GetOldTELEFONO_1IsNull: Boolean; virtual;
    procedure SetTELEFONO_1Value(const aValue: String); virtual;
    procedure SetTELEFONO_1IsNull(const aValue: Boolean); virtual;
    function GetTELEFONO_2Value: String; virtual;
    function GetTELEFONO_2IsNull: Boolean; virtual;
    function GetOldTELEFONO_2Value: String; virtual;
    function GetOldTELEFONO_2IsNull: Boolean; virtual;
    procedure SetTELEFONO_2Value(const aValue: String); virtual;
    procedure SetTELEFONO_2IsNull(const aValue: Boolean); virtual;
    function GetMOVIL_1Value: String; virtual;
    function GetMOVIL_1IsNull: Boolean; virtual;
    function GetOldMOVIL_1Value: String; virtual;
    function GetOldMOVIL_1IsNull: Boolean; virtual;
    procedure SetMOVIL_1Value(const aValue: String); virtual;
    procedure SetMOVIL_1IsNull(const aValue: Boolean); virtual;
    function GetMOVIL_2Value: String; virtual;
    function GetMOVIL_2IsNull: Boolean; virtual;
    function GetOldMOVIL_2Value: String; virtual;
    function GetOldMOVIL_2IsNull: Boolean; virtual;
    procedure SetMOVIL_2Value(const aValue: String); virtual;
    procedure SetMOVIL_2IsNull(const aValue: Boolean); virtual;
    function GetFAXValue: String; virtual;
    function GetFAXIsNull: Boolean; virtual;
    function GetOldFAXValue: String; virtual;
    function GetOldFAXIsNull: Boolean; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    procedure SetFAXIsNull(const aValue: Boolean); virtual;
    function GetEMAIL_1Value: String; virtual;
    function GetEMAIL_1IsNull: Boolean; virtual;
    function GetOldEMAIL_1Value: String; virtual;
    function GetOldEMAIL_1IsNull: Boolean; virtual;
    procedure SetEMAIL_1Value(const aValue: String); virtual;
    procedure SetEMAIL_1IsNull(const aValue: Boolean); virtual;
    function GetEMAIL_2Value: String; virtual;
    function GetEMAIL_2IsNull: Boolean; virtual;
    function GetOldEMAIL_2Value: String; virtual;
    function GetOldEMAIL_2IsNull: Boolean; virtual;
    procedure SetEMAIL_2Value(const aValue: String); virtual;
    procedure SetEMAIL_2IsNull(const aValue: Boolean); virtual;
    function GetPAGINA_WEBValue: String; virtual;
    function GetPAGINA_WEBIsNull: Boolean; virtual;
    function GetOldPAGINA_WEBValue: String; virtual;
    function GetOldPAGINA_WEBIsNull: Boolean; virtual;
    procedure SetPAGINA_WEBValue(const aValue: String); virtual;
    procedure SetPAGINA_WEBIsNull(const aValue: Boolean); virtual;
    function GetNOTASValue: IROStrings; virtual;
    function GetNOTASIsNull: Boolean; virtual;
    function GetOldNOTASValue: IROStrings; virtual;
    function GetOldNOTASIsNull: Boolean; virtual;
    procedure SetNOTASIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    function GetOldFECHA_ALTAValue: DateTime; virtual;
    function GetOldFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    function GetOldFECHA_MODIFICACIONValue: DateTime; virtual;
    function GetOldFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    function GetOldUSUARIOValue: String; virtual;
    function GetOldUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetLOGOTIPOValue: IROStream; virtual;
    function GetLOGOTIPOIsNull: Boolean; virtual;
    function GetOldLOGOTIPOValue: IROStream; virtual;
    function GetOldLOGOTIPOIsNull: Boolean; virtual;
    procedure SetLOGOTIPOIsNull(const aValue: Boolean); virtual;
    function GetREGISTRO_MERCANTILValue: String; virtual;
    function GetREGISTRO_MERCANTILIsNull: Boolean; virtual;
    function GetOldREGISTRO_MERCANTILValue: String; virtual;
    function GetOldREGISTRO_MERCANTILIsNull: Boolean; virtual;
    procedure SetREGISTRO_MERCANTILValue(const aValue: String); virtual;
    procedure SetREGISTRO_MERCANTILIsNull(const aValue: Boolean); virtual;
    function GetPARAM_TIEMPOValue: Float; virtual;
    function GetPARAM_TIEMPOIsNull: Boolean; virtual;
    function GetOldPARAM_TIEMPOValue: Float; virtual;
    function GetOldPARAM_TIEMPOIsNull: Boolean; virtual;
    procedure SetPARAM_TIEMPOValue(const aValue: Float); virtual;
    procedure SetPARAM_TIEMPOIsNull(const aValue: Boolean); virtual;
    function GetPARAM_MARGENValue: Float; virtual;
    function GetPARAM_MARGENIsNull: Boolean; virtual;
    function GetOldPARAM_MARGENValue: Float; virtual;
    function GetOldPARAM_MARGENIsNull: Boolean; virtual;
    procedure SetPARAM_MARGENValue(const aValue: Float); virtual;
    procedure SetPARAM_MARGENIsNull(const aValue: Boolean); virtual;
    function GetID_TIPO_IVAValue: SmallInt; virtual;
    function GetID_TIPO_IVAIsNull: Boolean; virtual;
    function GetOldID_TIPO_IVAValue: SmallInt; virtual;
    function GetOldID_TIPO_IVAIsNull: Boolean; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: SmallInt); virtual;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: SmallInt; virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    function GetOldID_FORMA_PAGOValue: SmallInt; virtual;
    function GetOldID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: SmallInt); virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetID_ALMACENValue: SmallInt; virtual;
    function GetID_ALMACENIsNull: Boolean; virtual;
    function GetOldID_ALMACENValue: SmallInt; virtual;
    function GetOldID_ALMACENIsNull: Boolean; virtual;
    procedure SetID_ALMACENValue(const aValue: SmallInt); virtual;
    procedure SetID_ALMACENIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property NIF_CIF : String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull : Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property OldNIF_CIF : String read GetOldNIF_CIFValue;
    property OldNIF_CIFIsNull : Boolean read GetOldNIF_CIFIsNull;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull : Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldNOMBREIsNull : Boolean read GetOldNOMBREIsNull;
    property RAZON_SOCIAL : String read GetRAZON_SOCIALValue write SetRAZON_SOCIALValue;
    property RAZON_SOCIALIsNull : Boolean read GetRAZON_SOCIALIsNull write SetRAZON_SOCIALIsNull;
    property OldRAZON_SOCIAL : String read GetOldRAZON_SOCIALValue;
    property OldRAZON_SOCIALIsNull : Boolean read GetOldRAZON_SOCIALIsNull;
    property CALLE : String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull : Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property OldCALLE : String read GetOldCALLEValue;
    property OldCALLEIsNull : Boolean read GetOldCALLEIsNull;
    property POBLACION : String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull : Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property OldPOBLACION : String read GetOldPOBLACIONValue;
    property OldPOBLACIONIsNull : Boolean read GetOldPOBLACIONIsNull;
    property PROVINCIA : String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull : Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property OldPROVINCIA : String read GetOldPROVINCIAValue;
    property OldPROVINCIAIsNull : Boolean read GetOldPROVINCIAIsNull;
    property CODIGO_POSTAL : String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull : Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property OldCODIGO_POSTAL : String read GetOldCODIGO_POSTALValue;
    property OldCODIGO_POSTALIsNull : Boolean read GetOldCODIGO_POSTALIsNull;
    property TELEFONO_1 : String read GetTELEFONO_1Value write SetTELEFONO_1Value;
    property TELEFONO_1IsNull : Boolean read GetTELEFONO_1IsNull write SetTELEFONO_1IsNull;
    property OldTELEFONO_1 : String read GetOldTELEFONO_1Value;
    property OldTELEFONO_1IsNull : Boolean read GetOldTELEFONO_1IsNull;
    property TELEFONO_2 : String read GetTELEFONO_2Value write SetTELEFONO_2Value;
    property TELEFONO_2IsNull : Boolean read GetTELEFONO_2IsNull write SetTELEFONO_2IsNull;
    property OldTELEFONO_2 : String read GetOldTELEFONO_2Value;
    property OldTELEFONO_2IsNull : Boolean read GetOldTELEFONO_2IsNull;
    property MOVIL_1 : String read GetMOVIL_1Value write SetMOVIL_1Value;
    property MOVIL_1IsNull : Boolean read GetMOVIL_1IsNull write SetMOVIL_1IsNull;
    property OldMOVIL_1 : String read GetOldMOVIL_1Value;
    property OldMOVIL_1IsNull : Boolean read GetOldMOVIL_1IsNull;
    property MOVIL_2 : String read GetMOVIL_2Value write SetMOVIL_2Value;
    property MOVIL_2IsNull : Boolean read GetMOVIL_2IsNull write SetMOVIL_2IsNull;
    property OldMOVIL_2 : String read GetOldMOVIL_2Value;
    property OldMOVIL_2IsNull : Boolean read GetOldMOVIL_2IsNull;
    property FAX : String read GetFAXValue write SetFAXValue;
    property FAXIsNull : Boolean read GetFAXIsNull write SetFAXIsNull;
    property OldFAX : String read GetOldFAXValue;
    property OldFAXIsNull : Boolean read GetOldFAXIsNull;
    property EMAIL_1 : String read GetEMAIL_1Value write SetEMAIL_1Value;
    property EMAIL_1IsNull : Boolean read GetEMAIL_1IsNull write SetEMAIL_1IsNull;
    property OldEMAIL_1 : String read GetOldEMAIL_1Value;
    property OldEMAIL_1IsNull : Boolean read GetOldEMAIL_1IsNull;
    property EMAIL_2 : String read GetEMAIL_2Value write SetEMAIL_2Value;
    property EMAIL_2IsNull : Boolean read GetEMAIL_2IsNull write SetEMAIL_2IsNull;
    property OldEMAIL_2 : String read GetOldEMAIL_2Value;
    property OldEMAIL_2IsNull : Boolean read GetOldEMAIL_2IsNull;
    property PAGINA_WEB : String read GetPAGINA_WEBValue write SetPAGINA_WEBValue;
    property PAGINA_WEBIsNull : Boolean read GetPAGINA_WEBIsNull write SetPAGINA_WEBIsNull;
    property OldPAGINA_WEB : String read GetOldPAGINA_WEBValue;
    property OldPAGINA_WEBIsNull : Boolean read GetOldPAGINA_WEBIsNull;
    property NOTAS : IROStrings read GetNOTASValue;
    property NOTASIsNull : Boolean read GetNOTASIsNull write SetNOTASIsNull;
    property OldNOTAS : IROStrings read GetOldNOTASValue;
    property OldNOTASIsNull : Boolean read GetOldNOTASIsNull;
    property FECHA_ALTA : DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull : Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property OldFECHA_ALTAIsNull : Boolean read GetOldFECHA_ALTAIsNull;
    property FECHA_MODIFICACION : DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull : Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property OldFECHA_MODIFICACIONIsNull : Boolean read GetOldFECHA_MODIFICACIONIsNull;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull : Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldUSUARIOIsNull : Boolean read GetOldUSUARIOIsNull;
    property LOGOTIPO : IROStream read GetLOGOTIPOValue;
    property LOGOTIPOIsNull : Boolean read GetLOGOTIPOIsNull write SetLOGOTIPOIsNull;
    property OldLOGOTIPO : IROStream read GetOldLOGOTIPOValue;
    property OldLOGOTIPOIsNull : Boolean read GetOldLOGOTIPOIsNull;
    property REGISTRO_MERCANTIL : String read GetREGISTRO_MERCANTILValue write SetREGISTRO_MERCANTILValue;
    property REGISTRO_MERCANTILIsNull : Boolean read GetREGISTRO_MERCANTILIsNull write SetREGISTRO_MERCANTILIsNull;
    property OldREGISTRO_MERCANTIL : String read GetOldREGISTRO_MERCANTILValue;
    property OldREGISTRO_MERCANTILIsNull : Boolean read GetOldREGISTRO_MERCANTILIsNull;
    property PARAM_TIEMPO : Float read GetPARAM_TIEMPOValue write SetPARAM_TIEMPOValue;
    property PARAM_TIEMPOIsNull : Boolean read GetPARAM_TIEMPOIsNull write SetPARAM_TIEMPOIsNull;
    property OldPARAM_TIEMPO : Float read GetOldPARAM_TIEMPOValue;
    property OldPARAM_TIEMPOIsNull : Boolean read GetOldPARAM_TIEMPOIsNull;
    property PARAM_MARGEN : Float read GetPARAM_MARGENValue write SetPARAM_MARGENValue;
    property PARAM_MARGENIsNull : Boolean read GetPARAM_MARGENIsNull write SetPARAM_MARGENIsNull;
    property OldPARAM_MARGEN : Float read GetOldPARAM_MARGENValue;
    property OldPARAM_MARGENIsNull : Boolean read GetOldPARAM_MARGENIsNull;
    property ID_TIPO_IVA : SmallInt read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull : Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property OldID_TIPO_IVA : SmallInt read GetOldID_TIPO_IVAValue;
    property OldID_TIPO_IVAIsNull : Boolean read GetOldID_TIPO_IVAIsNull;
    property ID_FORMA_PAGO : SmallInt read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull : Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property OldID_FORMA_PAGO : SmallInt read GetOldID_FORMA_PAGOValue;
    property OldID_FORMA_PAGOIsNull : Boolean read GetOldID_FORMA_PAGOIsNull;
    property ID_ALMACEN : SmallInt read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull : Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property OldID_ALMACEN : SmallInt read GetOldID_ALMACENValue;
    property OldID_ALMACENIsNull : Boolean read GetOldID_ALMACENIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IEmpresasDatosBancoDelta }
  IEmpresasDatosBancoDelta = interface(IEmpresasDatosBanco)
  ['{A79108BB-E362-4338-9188-6D5683DCE289}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldNOMBREValue : String;
    function GetOldENTIDADValue : String;
    function GetOldSUCURSALValue : String;
    function GetOldDCValue : String;
    function GetOldCUENTAValue : String;
    function GetOldSUFIJO_N19Value : String;
    function GetOldSUFIJO_N58Value : String;
    function GetOldIBANValue : String;
    function GetOldSWIFTValue : String;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldENTIDAD : String read GetOldENTIDADValue;
    property OldSUCURSAL : String read GetOldSUCURSALValue;
    property OldDC : String read GetOldDCValue;
    property OldCUENTA : String read GetOldCUENTAValue;
    property OldSUFIJO_N19 : String read GetOldSUFIJO_N19Value;
    property OldSUFIJO_N58 : String read GetOldSUFIJO_N58Value;
    property OldIBAN : String read GetOldIBANValue;
    property OldSWIFT : String read GetOldSWIFTValue;
  end;

  { TEmpresasDatosBancoBusinessProcessorRules }
  TEmpresasDatosBancoBusinessProcessorRules = class(TDABusinessProcessorRules, IEmpresasDatosBanco, IEmpresasDatosBancoDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    function GetOldNOMBREValue: String; virtual;
    function GetOldNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetENTIDADValue: String; virtual;
    function GetENTIDADIsNull: Boolean; virtual;
    function GetOldENTIDADValue: String; virtual;
    function GetOldENTIDADIsNull: Boolean; virtual;
    procedure SetENTIDADValue(const aValue: String); virtual;
    procedure SetENTIDADIsNull(const aValue: Boolean); virtual;
    function GetSUCURSALValue: String; virtual;
    function GetSUCURSALIsNull: Boolean; virtual;
    function GetOldSUCURSALValue: String; virtual;
    function GetOldSUCURSALIsNull: Boolean; virtual;
    procedure SetSUCURSALValue(const aValue: String); virtual;
    procedure SetSUCURSALIsNull(const aValue: Boolean); virtual;
    function GetDCValue: String; virtual;
    function GetDCIsNull: Boolean; virtual;
    function GetOldDCValue: String; virtual;
    function GetOldDCIsNull: Boolean; virtual;
    procedure SetDCValue(const aValue: String); virtual;
    procedure SetDCIsNull(const aValue: Boolean); virtual;
    function GetCUENTAValue: String; virtual;
    function GetCUENTAIsNull: Boolean; virtual;
    function GetOldCUENTAValue: String; virtual;
    function GetOldCUENTAIsNull: Boolean; virtual;
    procedure SetCUENTAValue(const aValue: String); virtual;
    procedure SetCUENTAIsNull(const aValue: Boolean); virtual;
    function GetSUFIJO_N19Value: String; virtual;
    function GetSUFIJO_N19IsNull: Boolean; virtual;
    function GetOldSUFIJO_N19Value: String; virtual;
    function GetOldSUFIJO_N19IsNull: Boolean; virtual;
    procedure SetSUFIJO_N19Value(const aValue: String); virtual;
    procedure SetSUFIJO_N19IsNull(const aValue: Boolean); virtual;
    function GetSUFIJO_N58Value: String; virtual;
    function GetSUFIJO_N58IsNull: Boolean; virtual;
    function GetOldSUFIJO_N58Value: String; virtual;
    function GetOldSUFIJO_N58IsNull: Boolean; virtual;
    procedure SetSUFIJO_N58Value(const aValue: String); virtual;
    procedure SetSUFIJO_N58IsNull(const aValue: Boolean); virtual;
    function GetIBANValue: String; virtual;
    function GetIBANIsNull: Boolean; virtual;
    function GetOldIBANValue: String; virtual;
    function GetOldIBANIsNull: Boolean; virtual;
    procedure SetIBANValue(const aValue: String); virtual;
    procedure SetIBANIsNull(const aValue: Boolean); virtual;
    function GetSWIFTValue: String; virtual;
    function GetSWIFTIsNull: Boolean; virtual;
    function GetOldSWIFTValue: String; virtual;
    function GetOldSWIFTIsNull: Boolean; virtual;
    procedure SetSWIFTValue(const aValue: String); virtual;
    procedure SetSWIFTIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull : Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldID_EMPRESAIsNull : Boolean read GetOldID_EMPRESAIsNull;
    property NOMBRE : String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull : Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property OldNOMBRE : String read GetOldNOMBREValue;
    property OldNOMBREIsNull : Boolean read GetOldNOMBREIsNull;
    property ENTIDAD : String read GetENTIDADValue write SetENTIDADValue;
    property ENTIDADIsNull : Boolean read GetENTIDADIsNull write SetENTIDADIsNull;
    property OldENTIDAD : String read GetOldENTIDADValue;
    property OldENTIDADIsNull : Boolean read GetOldENTIDADIsNull;
    property SUCURSAL : String read GetSUCURSALValue write SetSUCURSALValue;
    property SUCURSALIsNull : Boolean read GetSUCURSALIsNull write SetSUCURSALIsNull;
    property OldSUCURSAL : String read GetOldSUCURSALValue;
    property OldSUCURSALIsNull : Boolean read GetOldSUCURSALIsNull;
    property DC : String read GetDCValue write SetDCValue;
    property DCIsNull : Boolean read GetDCIsNull write SetDCIsNull;
    property OldDC : String read GetOldDCValue;
    property OldDCIsNull : Boolean read GetOldDCIsNull;
    property CUENTA : String read GetCUENTAValue write SetCUENTAValue;
    property CUENTAIsNull : Boolean read GetCUENTAIsNull write SetCUENTAIsNull;
    property OldCUENTA : String read GetOldCUENTAValue;
    property OldCUENTAIsNull : Boolean read GetOldCUENTAIsNull;
    property SUFIJO_N19 : String read GetSUFIJO_N19Value write SetSUFIJO_N19Value;
    property SUFIJO_N19IsNull : Boolean read GetSUFIJO_N19IsNull write SetSUFIJO_N19IsNull;
    property OldSUFIJO_N19 : String read GetOldSUFIJO_N19Value;
    property OldSUFIJO_N19IsNull : Boolean read GetOldSUFIJO_N19IsNull;
    property SUFIJO_N58 : String read GetSUFIJO_N58Value write SetSUFIJO_N58Value;
    property SUFIJO_N58IsNull : Boolean read GetSUFIJO_N58IsNull write SetSUFIJO_N58IsNull;
    property OldSUFIJO_N58 : String read GetOldSUFIJO_N58Value;
    property OldSUFIJO_N58IsNull : Boolean read GetOldSUFIJO_N58IsNull;
    property IBAN : String read GetIBANValue write SetIBANValue;
    property IBANIsNull : Boolean read GetIBANIsNull write SetIBANIsNull;
    property OldIBAN : String read GetOldIBANValue;
    property OldIBANIsNull : Boolean read GetOldIBANIsNull;
    property SWIFT : String read GetSWIFTValue write SetSWIFTValue;
    property SWIFTIsNull : Boolean read GetSWIFTIsNull write SetSWIFTIsNull;
    property OldSWIFT : String read GetOldSWIFTValue;
    property OldSWIFTIsNull : Boolean read GetOldSWIFTIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TEmpresasBusinessProcessorRules }
constructor TEmpresasBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
var
  StrList: TStringList;
  ROStream: TROStream;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := NOTAS_OnChange;
  f_NOTAS := NewROStrings(StrList,True);

  ROStream := TROStream.Create;
  ROStream.OnChange := LOGOTIPO_OnChange;
  f_LOGOTIPO := ROStream;
end;

destructor TEmpresasBusinessProcessorRules.Destroy;
begin
  inherited;
end;

procedure TEmpresasBusinessProcessorRules.NOTAS_OnChange(Sender: TObject);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOTAS] := TStringList(Sender).Text;
end;

procedure TEmpresasBusinessProcessorRules.LOGOTIPO_OnChange(Sender: TObject);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasLOGOTIPO] := BinaryToBlobVariant((TROStream(Sender) as IROStream).Stream);
end;

function TEmpresasBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID];
end;

function TEmpresasBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID]);
end;

function TEmpresasBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID];
end;

function TEmpresasBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID]);
end;

procedure TEmpresasBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID] := Null;
end;

function TEmpresasBusinessProcessorRules.GetNIF_CIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNIF_CIF];
end;

function TEmpresasBusinessProcessorRules.GetNIF_CIFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNIF_CIF]);
end;

function TEmpresasBusinessProcessorRules.GetOldNIF_CIFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNIF_CIF];
end;

function TEmpresasBusinessProcessorRules.GetOldNIF_CIFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNIF_CIF]);
end;

procedure TEmpresasBusinessProcessorRules.SetNIF_CIFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNIF_CIF] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetNIF_CIFIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNIF_CIF] := Null;
end;

function TEmpresasBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOMBRE];
end;

function TEmpresasBusinessProcessorRules.GetNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOMBRE]);
end;

function TEmpresasBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNOMBRE];
end;

function TEmpresasBusinessProcessorRules.GetOldNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNOMBRE]);
end;

procedure TEmpresasBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOMBRE] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOMBRE] := Null;
end;

function TEmpresasBusinessProcessorRules.GetRAZON_SOCIALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasRAZON_SOCIAL];
end;

function TEmpresasBusinessProcessorRules.GetRAZON_SOCIALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasRAZON_SOCIAL]);
end;

function TEmpresasBusinessProcessorRules.GetOldRAZON_SOCIALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasRAZON_SOCIAL];
end;

function TEmpresasBusinessProcessorRules.GetOldRAZON_SOCIALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasRAZON_SOCIAL]);
end;

procedure TEmpresasBusinessProcessorRules.SetRAZON_SOCIALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasRAZON_SOCIAL] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetRAZON_SOCIALIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasRAZON_SOCIAL] := Null;
end;

function TEmpresasBusinessProcessorRules.GetCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCALLE];
end;

function TEmpresasBusinessProcessorRules.GetCALLEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCALLE]);
end;

function TEmpresasBusinessProcessorRules.GetOldCALLEValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasCALLE];
end;

function TEmpresasBusinessProcessorRules.GetOldCALLEIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasCALLE]);
end;

procedure TEmpresasBusinessProcessorRules.SetCALLEValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCALLE] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCALLE] := Null;
end;

function TEmpresasBusinessProcessorRules.GetPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPOBLACION];
end;

function TEmpresasBusinessProcessorRules.GetPOBLACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPOBLACION]);
end;

function TEmpresasBusinessProcessorRules.GetOldPOBLACIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPOBLACION];
end;

function TEmpresasBusinessProcessorRules.GetOldPOBLACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPOBLACION]);
end;

procedure TEmpresasBusinessProcessorRules.SetPOBLACIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPOBLACION] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPOBLACION] := Null;
end;

function TEmpresasBusinessProcessorRules.GetPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPROVINCIA];
end;

function TEmpresasBusinessProcessorRules.GetPROVINCIAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPROVINCIA]);
end;

function TEmpresasBusinessProcessorRules.GetOldPROVINCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPROVINCIA];
end;

function TEmpresasBusinessProcessorRules.GetOldPROVINCIAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPROVINCIA]);
end;

procedure TEmpresasBusinessProcessorRules.SetPROVINCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPROVINCIA] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPROVINCIA] := Null;
end;

function TEmpresasBusinessProcessorRules.GetCODIGO_POSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCODIGO_POSTAL];
end;

function TEmpresasBusinessProcessorRules.GetCODIGO_POSTALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCODIGO_POSTAL]);
end;

function TEmpresasBusinessProcessorRules.GetOldCODIGO_POSTALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasCODIGO_POSTAL];
end;

function TEmpresasBusinessProcessorRules.GetOldCODIGO_POSTALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasCODIGO_POSTAL]);
end;

procedure TEmpresasBusinessProcessorRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCODIGO_POSTAL] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasCODIGO_POSTAL] := Null;
end;

function TEmpresasBusinessProcessorRules.GetTELEFONO_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_1];
end;

function TEmpresasBusinessProcessorRules.GetTELEFONO_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_1]);
end;

function TEmpresasBusinessProcessorRules.GetOldTELEFONO_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasTELEFONO_1];
end;

function TEmpresasBusinessProcessorRules.GetOldTELEFONO_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasTELEFONO_1]);
end;

procedure TEmpresasBusinessProcessorRules.SetTELEFONO_1Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_1] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetTELEFONO_1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_1] := Null;
end;

function TEmpresasBusinessProcessorRules.GetTELEFONO_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_2];
end;

function TEmpresasBusinessProcessorRules.GetTELEFONO_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_2]);
end;

function TEmpresasBusinessProcessorRules.GetOldTELEFONO_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasTELEFONO_2];
end;

function TEmpresasBusinessProcessorRules.GetOldTELEFONO_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasTELEFONO_2]);
end;

procedure TEmpresasBusinessProcessorRules.SetTELEFONO_2Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_2] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetTELEFONO_2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasTELEFONO_2] := Null;
end;

function TEmpresasBusinessProcessorRules.GetMOVIL_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_1];
end;

function TEmpresasBusinessProcessorRules.GetMOVIL_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_1]);
end;

function TEmpresasBusinessProcessorRules.GetOldMOVIL_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasMOVIL_1];
end;

function TEmpresasBusinessProcessorRules.GetOldMOVIL_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasMOVIL_1]);
end;

procedure TEmpresasBusinessProcessorRules.SetMOVIL_1Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_1] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetMOVIL_1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_1] := Null;
end;

function TEmpresasBusinessProcessorRules.GetMOVIL_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_2];
end;

function TEmpresasBusinessProcessorRules.GetMOVIL_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_2]);
end;

function TEmpresasBusinessProcessorRules.GetOldMOVIL_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasMOVIL_2];
end;

function TEmpresasBusinessProcessorRules.GetOldMOVIL_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasMOVIL_2]);
end;

procedure TEmpresasBusinessProcessorRules.SetMOVIL_2Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_2] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetMOVIL_2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasMOVIL_2] := Null;
end;

function TEmpresasBusinessProcessorRules.GetFAXValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFAX];
end;

function TEmpresasBusinessProcessorRules.GetFAXIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFAX]);
end;

function TEmpresasBusinessProcessorRules.GetOldFAXValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFAX];
end;

function TEmpresasBusinessProcessorRules.GetOldFAXIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFAX]);
end;

procedure TEmpresasBusinessProcessorRules.SetFAXValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFAX] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetFAXIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFAX] := Null;
end;

function TEmpresasBusinessProcessorRules.GetEMAIL_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_1];
end;

function TEmpresasBusinessProcessorRules.GetEMAIL_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_1]);
end;

function TEmpresasBusinessProcessorRules.GetOldEMAIL_1Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasEMAIL_1];
end;

function TEmpresasBusinessProcessorRules.GetOldEMAIL_1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasEMAIL_1]);
end;

procedure TEmpresasBusinessProcessorRules.SetEMAIL_1Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_1] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetEMAIL_1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_1] := Null;
end;

function TEmpresasBusinessProcessorRules.GetEMAIL_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_2];
end;

function TEmpresasBusinessProcessorRules.GetEMAIL_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_2]);
end;

function TEmpresasBusinessProcessorRules.GetOldEMAIL_2Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasEMAIL_2];
end;

function TEmpresasBusinessProcessorRules.GetOldEMAIL_2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasEMAIL_2]);
end;

procedure TEmpresasBusinessProcessorRules.SetEMAIL_2Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_2] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetEMAIL_2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasEMAIL_2] := Null;
end;

function TEmpresasBusinessProcessorRules.GetPAGINA_WEBValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPAGINA_WEB];
end;

function TEmpresasBusinessProcessorRules.GetPAGINA_WEBIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPAGINA_WEB]);
end;

function TEmpresasBusinessProcessorRules.GetOldPAGINA_WEBValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPAGINA_WEB];
end;

function TEmpresasBusinessProcessorRules.GetOldPAGINA_WEBIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPAGINA_WEB]);
end;

procedure TEmpresasBusinessProcessorRules.SetPAGINA_WEBValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPAGINA_WEB] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetPAGINA_WEBIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPAGINA_WEB] := Null;
end;

function TEmpresasBusinessProcessorRules.GetNOTASValue: IROStrings;
begin
  result := f_NOTAS;
  result.Text := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOTAS];
end;

function TEmpresasBusinessProcessorRules.GetNOTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOTAS]);
end;

function TEmpresasBusinessProcessorRules.GetOldNOTASValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNOTAS];
end;

function TEmpresasBusinessProcessorRules.GetOldNOTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasNOTAS]);
end;

procedure TEmpresasBusinessProcessorRules.SetNOTASIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasNOTAS] := Null;
end;

function TEmpresasBusinessProcessorRules.GetFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_ALTA];
end;

function TEmpresasBusinessProcessorRules.GetFECHA_ALTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_ALTA]);
end;

function TEmpresasBusinessProcessorRules.GetOldFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFECHA_ALTA];
end;

function TEmpresasBusinessProcessorRules.GetOldFECHA_ALTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFECHA_ALTA]);
end;

procedure TEmpresasBusinessProcessorRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_ALTA] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_ALTA] := Null;
end;

function TEmpresasBusinessProcessorRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_MODIFICACION];
end;

function TEmpresasBusinessProcessorRules.GetFECHA_MODIFICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_MODIFICACION]);
end;

function TEmpresasBusinessProcessorRules.GetOldFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFECHA_MODIFICACION];
end;

function TEmpresasBusinessProcessorRules.GetOldFECHA_MODIFICACIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasFECHA_MODIFICACION]);
end;

procedure TEmpresasBusinessProcessorRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_MODIFICACION] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasFECHA_MODIFICACION] := Null;
end;

function TEmpresasBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasUSUARIO];
end;

function TEmpresasBusinessProcessorRules.GetUSUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasUSUARIO]);
end;

function TEmpresasBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasUSUARIO];
end;

function TEmpresasBusinessProcessorRules.GetOldUSUARIOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasUSUARIO]);
end;

procedure TEmpresasBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasUSUARIO] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasUSUARIO] := Null;
end;

function TEmpresasBusinessProcessorRules.GetLOGOTIPOValue: IROStream;
begin
  result := f_LOGOTIPO;
  result.Position := 0;
  if not Result.InUpdateMode then begin
    BlobVariantToBinary(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasLOGOTIPO], result.Stream);
    result.Position := 0;
  end;
end;

function TEmpresasBusinessProcessorRules.GetLOGOTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasLOGOTIPO]);
end;

function TEmpresasBusinessProcessorRules.GetOldLOGOTIPOValue: IROStream;
begin
  result := NewROStream();
  BlobVariantToBinary(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasLOGOTIPO], result.Stream);
end;

function TEmpresasBusinessProcessorRules.GetOldLOGOTIPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasLOGOTIPO]);
end;

procedure TEmpresasBusinessProcessorRules.SetLOGOTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasLOGOTIPO] := Null;
end;

function TEmpresasBusinessProcessorRules.GetREGISTRO_MERCANTILValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasREGISTRO_MERCANTIL];
end;

function TEmpresasBusinessProcessorRules.GetREGISTRO_MERCANTILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasREGISTRO_MERCANTIL]);
end;

function TEmpresasBusinessProcessorRules.GetOldREGISTRO_MERCANTILValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasREGISTRO_MERCANTIL];
end;

function TEmpresasBusinessProcessorRules.GetOldREGISTRO_MERCANTILIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasREGISTRO_MERCANTIL]);
end;

procedure TEmpresasBusinessProcessorRules.SetREGISTRO_MERCANTILValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasREGISTRO_MERCANTIL] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetREGISTRO_MERCANTILIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasREGISTRO_MERCANTIL] := Null;
end;

function TEmpresasBusinessProcessorRules.GetPARAM_TIEMPOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_TIEMPO];
end;

function TEmpresasBusinessProcessorRules.GetPARAM_TIEMPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_TIEMPO]);
end;

function TEmpresasBusinessProcessorRules.GetOldPARAM_TIEMPOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPARAM_TIEMPO];
end;

function TEmpresasBusinessProcessorRules.GetOldPARAM_TIEMPOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPARAM_TIEMPO]);
end;

procedure TEmpresasBusinessProcessorRules.SetPARAM_TIEMPOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_TIEMPO] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetPARAM_TIEMPOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_TIEMPO] := Null;
end;

function TEmpresasBusinessProcessorRules.GetPARAM_MARGENValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_MARGEN];
end;

function TEmpresasBusinessProcessorRules.GetPARAM_MARGENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_MARGEN]);
end;

function TEmpresasBusinessProcessorRules.GetOldPARAM_MARGENValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPARAM_MARGEN];
end;

function TEmpresasBusinessProcessorRules.GetOldPARAM_MARGENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasPARAM_MARGEN]);
end;

procedure TEmpresasBusinessProcessorRules.SetPARAM_MARGENValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_MARGEN] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetPARAM_MARGENIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasPARAM_MARGEN] := Null;
end;

function TEmpresasBusinessProcessorRules.GetID_TIPO_IVAValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_TIPO_IVA];
end;

function TEmpresasBusinessProcessorRules.GetID_TIPO_IVAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_TIPO_IVA]);
end;

function TEmpresasBusinessProcessorRules.GetOldID_TIPO_IVAValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_TIPO_IVA];
end;

function TEmpresasBusinessProcessorRules.GetOldID_TIPO_IVAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_TIPO_IVA]);
end;

procedure TEmpresasBusinessProcessorRules.SetID_TIPO_IVAValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_TIPO_IVA] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetID_TIPO_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_TIPO_IVA] := Null;
end;

function TEmpresasBusinessProcessorRules.GetID_FORMA_PAGOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_FORMA_PAGO];
end;

function TEmpresasBusinessProcessorRules.GetID_FORMA_PAGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_FORMA_PAGO]);
end;

function TEmpresasBusinessProcessorRules.GetOldID_FORMA_PAGOValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_FORMA_PAGO];
end;

function TEmpresasBusinessProcessorRules.GetOldID_FORMA_PAGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_FORMA_PAGO]);
end;

procedure TEmpresasBusinessProcessorRules.SetID_FORMA_PAGOValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_FORMA_PAGO] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_FORMA_PAGO] := Null;
end;

function TEmpresasBusinessProcessorRules.GetID_ALMACENValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_ALMACEN];
end;

function TEmpresasBusinessProcessorRules.GetID_ALMACENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_ALMACEN]);
end;

function TEmpresasBusinessProcessorRules.GetOldID_ALMACENValue: SmallInt;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_ALMACEN];
end;

function TEmpresasBusinessProcessorRules.GetOldID_ALMACENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasID_ALMACEN]);
end;

procedure TEmpresasBusinessProcessorRules.SetID_ALMACENValue(const aValue: SmallInt);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_ALMACEN] := aValue;
end;

procedure TEmpresasBusinessProcessorRules.SetID_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasID_ALMACEN] := Null;
end;


{ TEmpresasDatosBancoBusinessProcessorRules }
constructor TEmpresasDatosBancoBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TEmpresasDatosBancoBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoID];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoID]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID_EMPRESA];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID_EMPRESA]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoID_EMPRESA];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoID_EMPRESA]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID_EMPRESA] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoID_EMPRESA] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoNOMBRE];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoNOMBRE]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldNOMBREValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoNOMBRE];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldNOMBREIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoNOMBRE]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetNOMBREValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoNOMBRE] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoNOMBRE] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetENTIDADValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoENTIDAD];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetENTIDADIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoENTIDAD]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldENTIDADValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoENTIDAD];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldENTIDADIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoENTIDAD]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetENTIDADValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoENTIDAD] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetENTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoENTIDAD] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUCURSALValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUCURSAL];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUCURSALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUCURSAL]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUCURSALValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUCURSAL];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUCURSALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUCURSAL]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUCURSALValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUCURSAL] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUCURSALIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUCURSAL] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetDCValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoDC];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetDCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoDC]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldDCValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoDC];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldDCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoDC]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetDCValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoDC] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetDCIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoDC] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetCUENTAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoCUENTA];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetCUENTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoCUENTA]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldCUENTAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoCUENTA];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldCUENTAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoCUENTA]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetCUENTAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoCUENTA] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetCUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoCUENTA] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUFIJO_N19Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N19];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUFIJO_N19IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N19]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUFIJO_N19Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUFIJO_N19];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUFIJO_N19IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUFIJO_N19]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUFIJO_N19Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N19] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUFIJO_N19IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N19] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUFIJO_N58Value: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N58];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSUFIJO_N58IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N58]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUFIJO_N58Value: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUFIJO_N58];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSUFIJO_N58IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSUFIJO_N58]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUFIJO_N58Value(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N58] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSUFIJO_N58IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSUFIJO_N58] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetIBANValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoIBAN];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetIBANIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoIBAN]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldIBANValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoIBAN];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldIBANIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoIBAN]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetIBANValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoIBAN] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetIBANIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoIBAN] := Null;
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSWIFTValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSWIFT];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetSWIFTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSWIFT]);
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSWIFTValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSWIFT];
end;

function TEmpresasDatosBancoBusinessProcessorRules.GetOldSWIFTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_EmpresasDatosBancoSWIFT]);
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSWIFTValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSWIFT] := aValue;
end;

procedure TEmpresasDatosBancoBusinessProcessorRules.SetSWIFTIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_EmpresasDatosBancoSWIFT] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_EmpresasDelta, TEmpresasBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_EmpresasDatosBancoDelta, TEmpresasDatosBancoBusinessProcessorRules);

end.
